<template>
  <i-wrapper top>
    <div class="d-flex flex-column align-items-center justify-content-center flex-1">
      <img src="~assets/images/scientist-telescope.png" class="scientist-telescope" />
      <img src="~assets/images/bubbles-orange.svg" class="bubbles bubbles--custom" />
      <div class="title px-1 text-center mb-1">{{ $t(`Analyzing your info...`) }}</div>
    </div>
    <i-curtain class="i-curtain--custom" :flex="0">
      <template #bottom>
        <template v-if="group === 0">
          <div class="line line--1">{{ $t(`Birth Date`) }}: {{ birthDateString }}</div>
          <div class="line line--2">{{ $t(`Birth Time`) }}: {{ birthTimeString }}</div>
        </template>
        <template v-if="group === 1">
          <div class="line line--1">{{ $t(`Birth Place`) }}: {{ birthPlaceString }}</div>
          <div class="line line--2">{{ $t(`Coordinates`) }}: {{ coordinatesString }}</div>
        </template>
        <template v-if="group === 2">
          <div class="line line--1">
            {{ $t(`planetNames.sun`) }}: {{ $t(`signNames.aquarius`) }}, in the 3rd house
            <img src="~assets/images/house-1a.svg" class="line-icon" />
          </div>
          <div class="line line--2">
            Moon: Gemini, in the 7th house <img src="~assets/images/house-1b.svg" class="line-icon" />
          </div>
        </template>
        <template v-if="group === 3">
          <div class="line line--1">
            Moon: Gemini, in the 7th house <img src="~assets/images/house-1b.svg" class="line-icon" />
          </div>
          <div class="line line--2">
            Mars: Pisces, in the 5rd house <img src="~assets/images/house-1a.svg" class="line-icon" />
          </div>
        </template>
        <template v-if="group === 4">
          <div class="line line--1">
            Mars: Pisces, in the 5rd house <img src="~assets/images/house-1a.svg" class="line-icon" />
          </div>
          <div class="line line--2">
            Mercury: Capricorn, in the 3th house <img src="~assets/images/house-1b.svg" class="line-icon" />
          </div>
        </template>
        <template v-if="group === 5">
          <div class="line line--1">
            Jupiter: Capricorn, in the 3rd house <img src="~assets/images/house-1a.svg" class="line-icon" />
          </div>
          <div class="line line--2">
            Venus: Pisces, in the 5th house <img src="~assets/images/house-1b.svg" class="line-icon" />
          </div>
        </template>
        <template v-if="group === 6">
          <div class="line line--1">
            Venus: Pisces, in the 5th house <img src="~assets/images/house-1a.svg" class="line-icon" />
          </div>
          <div class="line line--2">
            Saturn: Scorpio, in the 1st house <img src="~assets/images/house-1b.svg" class="line-icon" />
          </div>
        </template>
        <template v-if="group === 7">
          <div class="line line--1">
            Uranus: Sagittarius, in the 2nd house <img src="~assets/images/house-1a.svg" class="line-icon" />
          </div>
          <div class="line line--2">
            Neptune: Capricon, in the 2nd house <img src="~assets/images/house-1b.svg" class="line-icon" />
          </div>
        </template>
        <i-progress-bar :percentage="percentage" :delay="delay" />
        <div class="bottom-text">PLEASE WAIT A MINUTE</div>
      </template>
    </i-curtain>
    <i-unlock-full-access ref="iUnlockFullAccess" />
  </i-wrapper>
</template>

<script>
  import { mapState } from 'vuex';
  import DmsCoordinates from 'dms-conversion';

  export default {
    layout: 'default',

    data() {
      return {
        isLoading: null,
        percentage: this.$route.query.iufa ? 100 : 0,
        speed: 250,
        delay: 100,
        group: this.$route.query.iufa ? 7 : 0,

        progressSteps: [
          { percents: 5, delay: 400, group: 0 }, // -200
          { percents: 5, delay: 500, group: 0 }, // -100
          { percents: 5, delay: 400, group: 0 }, // +300 // 0
          { percents: 5, delay: 800, group: 1 }, // +300
          { percents: 5, delay: 1600, group: 1 }, // +600
          { percents: 5, delay: 2000, group: 1 }, // 1000
          { percents: 5, delay: 1400, group: 2 }, // -300 // 600
          { percents: 5, delay: 900, group: 2 }, // +100
          { percents: 5, delay: 700, group: 2 }, // +400
          { percents: 5, delay: 800, group: 3 }, // +100 // 1200
          { percents: 5, delay: 400, group: 3 }, // -200 // 1000
          { percents: 5, delay: 500, group: 3 }, // -500 // 500
          { percents: 5, delay: 700, group: 4 }, // -400 // 100
          { percents: 5, delay: 600, group: 4 }, // 0 // 100
          { percents: 5, delay: 500, group: 5 }, // +200 // 300
          { percents: 5, delay: 900, group: 5 }, // 0 // 300
          { percents: 5, delay: 2000, group: 6 }, // -200 // 100
          { percents: 5, delay: 600, group: 6 }, // 0 // 100
          { percents: 5, delay: 500, group: 7 }, // +200 / 300
          { percents: 5, delay: 400, group: 7 }, // -300 / 0
        ],

        currentProgressStepIndex: 0,
        timeout: null,
      };
    },

    computed: {
      ...mapState(['auth']),

      birthDateString() {
        return this.$moment(this.auth.onboarding.birthDate).format('LL');
      },

      birthTimeString() {
        if (!this.auth.onboarding.birthTime) {
          return 'Unknown';
        }

        let utcOffset = Math.round(this.auth.onboarding.birthPlace.utcOffset / 60);

        return [
          this.$moment(this.auth.onboarding.birthDate + 'T' + this.auth.onboarding.birthTime).format('LTS'),
          `(UTC ${(utcOffset > 0 ? '+' : '') + utcOffset})`,
        ].join(' ');
      },

      birthPlaceString() {
        return this.auth.onboarding.birthPlace.description.split(/,/)[0].trim();
      },

      coordinatesString() {
        let dmsCoordinates = new DmsCoordinates(
          this.auth.onboarding.birthPlace.latitude,
          this.auth.onboarding.birthPlace.longitude
        );

        let [latD, latM, latS, latNsew] = dmsCoordinates.dmsArrays.latitude;
        let [lngD, lngM, lngS, lngNsew] = dmsCoordinates.dmsArrays.longitude;

        return [
          `${latD}°${latM}′${Math.round(latS)}″${latNsew}`,
          `${lngD}°${lngM}′${Math.round(lngS)}″${lngNsew}`,
        ].join(', ');
      },
    },

    async mounted() {
      if (!this.$route.query.iufa) {
        this.runCurrentProgressStep();
      }
    },

    beforeDestroy() {
      this.timeout && clearTimeout(this.timeout);
      this.timeout = null;
    },

    methods: {
      runCurrentProgressStep() {
        let progressStep = this.progressSteps[this.currentProgressStepIndex] || null;
        this.percentage = Math.min(100, this.percentage + progressStep.percents);
        this.delay = progressStep.delay;
        this.group = progressStep.group;
        ++this.currentProgressStepIndex;

        this.timeout = setTimeout(async () => {
          try {
            this.timeout = null;

            if (this.percentage === 100 || this.currentProgressStepIndex >= this.progressSteps) {
              return await this.onProgressFinished();
            }

            return this.runCurrentProgressStep();
          } catch (error) {
            console.error(error);
          }
        }, progressStep.delay);
      },

      async onProgressFinished() {
        ga('send', 'event', 'preparing');

        if (!this.auth.user) {
          return this.$router.push(this.localePath({ name: 'authorization' }));
        }

        return this.$router.push({ name: 'today' });
      },
    },
  };
</script>

<style lang="scss" scoped>
  .scientist-telescope {
    width: rw(199px);
    margin-top: rs(62px);
  }

  .title {
    font-weight: bold;
    font-size: rf(20px);
    color: #fff;
    margin-top: rs(15px);
  }

  .bubbles--custom {
    top: rs(147px);
  }

  .line {
    display: flex;
    align-items: center;
    font-size: rf(16px);
    color: #575167;
    height: 19px;

    &--2 {
      margin-top: rs(15px);
      margin-bottom: rs(25px);
    }
  }

  .line-icon {
    width: rs(25px);
    margin-left: rs(10px);
  }

  .bottom-text {
    margin-top: rs(25px);
    color: #575167;
    font-size: rf(20px);
    text-align: center;
  }

  .i-curtain--custom .i-curtain__bottom {
    padding: rs(20px);
  }
</style>
